Loading...
Searching...
No Matches
ss7_asp.h File Reference
`#include <stdint.h>`
`#include <osmocom/core/linuxlist.h>`
`#include <osmocom/core/fsm.h>`
`#include <osmocom/core/msgb.h>`
`#include <osmocom/core/tdef.h>`
`#include <osmocom/netif/stream.h>`
`#include <osmocom/sigtran/osmo_ss7.h>`
`#include "ss7_asp_peer.h"`
`#include "ss7_internal.h"`

Go to the source code of this file.

## Data Structures

struct | osmo_ss7_asp

## Macros

#define | LOGPASP(asp, subsys, level, fmt, args ...)

## Enumerations

enum | ss7_asp_ctr { SS7_ASP_CTR_PKT_RX_TOTAL , SS7_ASP_CTR_PKT_RX_UNKNOWN , SS7_ASP_CTR_PKT_TX_TOTAL }

## Functions

struct osmo_ss7_asp * | ss7_asp_alloc (struct osmo_ss7_instance *inst, const char *name, uint16_t remote_port, uint16_t local_port, int trans_proto, enum osmo_ss7_asp_protocol proto)
bool | ss7_asp_set_default_peer_hosts (struct osmo_ss7_asp *asp)
bool | ss7_asp_is_started (const struct osmo_ss7_asp *asp)
int | ss7_asp_get_fd (const struct osmo_ss7_asp *asp)
| Get the fd of a given ASP.
int | ss7_asp_apply_peer_primary_address (const struct osmo_ss7_asp *asp)
int | ss7_asp_apply_primary_address (const struct osmo_ss7_asp *asp)
int | ss7_asp_apply_new_local_address (const struct osmo_ss7_asp *asp, unsigned int loc_idx)
int | ss7_asp_apply_drop_local_address (const struct osmo_ss7_asp *asp, unsigned int loc_idx)

## Macro Definition Documentation

## LOGPASP

#define LOGPASP | ( |  | asp,
|  |  | subsys,
|  |  | level,
|  |  | fmt,
|  |  | args ... )

Value:
_LOGSS7((asp)->inst, subsys, level, "asp-%s: " fmt, (asp)->cfg.name, ## args)
_LOGSS7
#define _LOGSS7(inst, subsys, level, fmt, args ...)
Definition ss7_instance.h:60

Referenced by handle_rkey_dereg(), handle_rkey_dereg_resp(), handle_rkey_reg(), handle_rkey_reg_resp(), ipa_rx_msg_ccm(), ipa_rx_msg_sccp(), log_sctp_notification(), m3ua_rx_mgmt_err(), m3ua_rx_mgmt_ntfy(), m3ua_rx_msg(), m3ua_rx_rkm(), m3ua_rx_rkm_reg_req(), m3ua_rx_snm(), m3ua_rx_snm_asp(), m3ua_rx_xfer(), osmo_ss7_asp_destroy(), osmo_ss7_asp_restart(), osmo_ss7_asp_send(), osmo_xlm_sap_down(), patch_sccp_with_pc(), ss7_asp_apply_drop_local_address(), ss7_asp_apply_new_local_address(), ss7_asp_apply_peer_primary_address(), ss7_asp_apply_primary_address(), ss7_asp_rx_unknown(), ss7_asp_xua_srv_conn_rx_cb(), sua_rx_mgmt_err(), sua_rx_mgmt_ntfy(), sua_rx_msg(), sua_rx_snm(), sua_rx_snm_asp(), xua_accept_cb(), xua_cli_connect_cb(), xua_cli_read_cb(), xua_find_as_for_asp(), xua_snm_rx_daud(), xua_snm_rx_dava(), xua_snm_rx_duna(), xua_snm_rx_dupu(), and xua_snm_rx_scon().

## Enumeration Type Documentation

## ss7_asp_ctr

enum ss7_asp_ctr

Enumerator
SS7_ASP_CTR_PKT_RX_TOTAL |
SS7_ASP_CTR_PKT_RX_UNKNOWN |
SS7_ASP_CTR_PKT_TX_TOTAL |

## Function Documentation

## ss7_asp_alloc()

struct osmo_ss7_asp * ss7_asp_alloc | ( | struct osmo_ss7_instance * | inst,
|  | const char * | name,
|  | uint16_t | remote_port,
|  | uint16_t | local_port,
|  | int | trans_proto,
|  | enum osmo_ss7_asp_protocol | proto )

References osmo_ss7_instance::asp_list, osmo_ss7_asp::cfg, osmo_ss7_asp::ctrg, g_ss7_asp_rcg_idx, osmo_ss7_asp::inst, osmo_ss7_asp::list, osmo_ss7_asp::local, osmo_ss7_asp::name, OSMO_SS7_ASP_PROT_SUA, osmo_ss7_asp_protocol_name(), osmo_ss7_ensure_sccp(), osmo_ss7_asp_peer::port, osmo_ss7_asp::proto, osmo_ss7_asp::remote, ss7_asp_lm_timer_defaults, ss7_asp_peer_init(), ss7_asp_protocol_check_trans_proto(), ss7_asp_rcgd, osmo_ss7_asp::T_defs_lm, and osmo_ss7_asp::trans_proto.

Referenced by osmo_ss7_asp_find_or_create2().

## ss7_asp_apply_drop_local_address()

int ss7_asp_apply_drop_local_address | ( | const struct osmo_ss7_asp * | asp,
|  | unsigned int | loc_idx )

References osmo_ss7_asp::cfg, osmo_ss7_asp::client, osmo_ss7_asp_peer::host, osmo_ss7_asp::is_server, osmo_ss7_asp::local, LOGPASP, and osmo_ss7_asp::server.

Referenced by DEFUN_ATTR().

## ss7_asp_apply_new_local_address()

int ss7_asp_apply_new_local_address | ( | const struct osmo_ss7_asp * | asp,
|  | unsigned int | loc_idx )

References osmo_ss7_asp::cfg, osmo_ss7_asp::client, osmo_ss7_asp_peer::host, osmo_ss7_asp::is_server, osmo_ss7_asp::local, LOGPASP, and osmo_ss7_asp::server.

Referenced by DEFUN_ATTR().

## ss7_asp_apply_peer_primary_address()

int ss7_asp_apply_peer_primary_address | ( | const struct osmo_ss7_asp * | asp | ) |

References _setsockopt_peer_primary_addr(), osmo_ss7_asp::cfg, osmo_ss7_asp::client, osmo_ss7_asp_peer::host, osmo_ss7_asp_peer::host_cnt, osmo_ss7_asp_peer::idx_primary, osmo_ss7_asp::is_server, osmo_ss7_asp::local, LOGPASP, osmo_ss7_asp_peer::port, and osmo_ss7_asp::server.

Referenced by DEFUN_ATTR(), xua_accept_cb(), and xua_cli_connect_cb().

## ss7_asp_apply_primary_address()

int ss7_asp_apply_primary_address | ( | const struct osmo_ss7_asp * | asp | ) |

References _setsockopt_primary_addr(), osmo_ss7_asp::cfg, osmo_ss7_asp::client, osmo_ss7_asp_peer::host, osmo_ss7_asp_peer::host_cnt, osmo_ss7_asp_peer::idx_primary, osmo_ss7_asp::is_server, LOGPASP, osmo_ss7_asp_peer::port, osmo_ss7_asp::remote, and osmo_ss7_asp::server.

Referenced by asp_handle_sctp_notif_monitor_primary_address(), DEFUN_ATTR(), xua_accept_cb(), and xua_cli_connect_cb().

## ss7_asp_get_fd()

int ss7_asp_get_fd | ( | const struct osmo_ss7_asp * | asp | ) |

Get the fd of a given ASP.

Parameters

  [in] | asp | The ASP for which the fd is requested

Returns
  The fd of the ASP if acailable, negative otherwise

References osmo_ss7_asp::cfg, osmo_ss7_asp::client, osmo_ss7_asp::is_server, and osmo_ss7_asp::server.

Referenced by show_one_asp(), show_one_asp_assoc_status_tcp(), and show_one_asp_remaddr_tcp().

## ss7_asp_is_started()

bool ss7_asp_is_started | ( | const struct osmo_ss7_asp * | asp | ) |

References osmo_ss7_asp::cfg, osmo_ss7_asp::client, osmo_ss7_asp::is_server, and osmo_ss7_asp::server.

Referenced by DEFUN_ATTR(), DEFUN_ATTR(), and DEFUN_ATTR().

## ss7_asp_set_default_peer_hosts()

bool ss7_asp_set_default_peer_hosts | ( | struct osmo_ss7_asp * | asp | ) |

References osmo_ss7_asp::cfg, osmo_ss7_asp_peer::host, osmo_ss7_asp_peer::host_cnt, osmo_ss7_asp::local, osmo_ss7_asp::remote, ss7_asp_peer_add_host(), and ss7_ipv6_sctp_supported().

Referenced by osmo_sccp_simple_client_on_ss7_id(), and osmo_ss7_vty_go_parent().